`timescale 1ns/1ns
module ISA_SV_test ;
   reg main_clk ;
   reg  CLK ; 
   reg  RST ; 
   wire DTR ; 
   wire TXD ; 
   reg  XIOCHDRY ; 
   reg [15:0] SD_REG ; 
   wire DSR ; 
   wire RXD ; 
   wire RESET_DEV ; 
   wire XSMEMW ; 
   wire XSMEMR ; 
   wire XIOW ; 
   wire XIOR ; 
   wire ISA_CLK ; 
   wire BALE ; 
   wire AEN ; 
   wire [15:0] SD ; 
   wire [19:0] SA ; 
   wire XIOCS6 ; 
   wire XMEMR ; 
   wire XMEMW ;
   reg IRQ3;
   reg IRQ4;
   reg IRQ5;
   reg IRQ7;
   reg IRQ9;
   reg IRQ10;
   reg IRQ11;
   reg IRQ12;
   wire [7:0] LED;
   wire [4:0] LED_SEL;
   reg SEND;
   reg [7:0] SEND_DT;
   wire RCV;
   wire [7:0]RCV_DT;
   wire XRST;
//   wire SW1;
   reg [7:0]TASK_CNT;
assign XRST = ~RST;
//assign SW1=1'b1;                
//
// test moudul 
//
   WEB_BLK DUT(
     .CLK(CLK),
     .XRST(XRST),
    // .DTR(DTR),
    // .TXD(TXD),
     .XIOCHDRY(XIOCHDRY),
   //  .DSR(DSR),
   //  .RXD(RXD),
     .RESET_DEV(RESET_DEV),
     .XSMEMW(XSMEMW),
     .XSMEMR(XSMEMR),
     .XIOW(XIOW),
     .XIOR(XIOR),
     .ISA_CLK(ISA_CLK),
     .BALE(BALE),
     .AEN(AEN),
     .SD(SD),
     .SA(SA),
     /*
     .XIOCS6(XIOCS6),
     .XMEMR(XMEMR),
     .XMEMW(XMEMW),
     .IRQ3(IRQ3),
     .IRQ4(IRQ4),
     .IRQ5(IRQ5),
     .IRQ7(IRQ7),
     .IRQ9(IRQ9),
     .IRQ10(IRQ10),
     .IRQ11(IRQ11),
     .IRQ12(IRQ12),
     */
     .LED(LED),
     .LED_SEL(LED_SEL)
     ); 
/*
DCE_IF DCE_IF_TST (
   .CLK(CLK)
  ,.RST(RST)
  ,.DSR(DTR)
  ,.RXD(TXD)
  ,.DTR(DSR)
  ,.TXD(RXD)
  ,.SEND(SEND)
  ,.SEND_DT(SEND_DT)
  ,.RCV(RCV)
  ,.RCV_DT(RCV_DT)
  );
*/
//
// main CLK genetator
//
  parameter CYCLE=100;
  always #(CYCLE/2)
    begin   
      main_clk = ~main_clk ;
      CLK = ~CLK;
    end
//
// I/O control
//
assign SD= ((XMEMR==1'b0)||(XIOR==1'b0))? SD_REG:16'bZZZZZZZZZZZZZZZZ;

//
// test pattern generator
//
parameter TIME_1 =6000;

always 
begin  
  TASK_CNT <= 8'd0;
  SD_REG <= 16'h0020; 
  @(posedge XIOR) 
  SD_REG <= 16'h0021; 
  @(posedge XIOR) 
  SD_REG <= 16'h0022; 
  @(posedge XIOR) 
  SD_REG <= 16'h0023;
  @(posedge XIOR) 
  SD_REG <= 16'h0024;
  @(posedge XIOR) 
  SD_REG <= 16'h0025;
  @(posedge XIOR) 
  SD_REG <= 16'h0026;
  @(posedge XIOR) 
  SD_REG <= 16'h0026; 
  @(posedge XIOR) 
  SD_REG <= 16'h0028;
  @(posedge XIOR) 
  SD_REG <= 16'h0001; //RSR
  @(posedge XIOR)
  SD_REG <= 16'h0020; 
  @(posedge XIOR) 
  SD_REG <= 16'h0021; 
  @(posedge XIOR) 
  SD_REG <= 16'h0052;
  //SD_REG <= 16'h0062;
  @(posedge XIOR) ;
  SD_REG <= 16'h0020; //MAX_DMA
  //SD_REG <= 16'h0062;
  @(posedge XIOR) ;  
  SD_REG <= 16'h0020; //to MAC1
  @(posedge XIOR) 
  SD_REG <= 16'h0021; //to MAC2 
  @(posedge XIOR) 
  SD_REG <= 16'h0022; //to MAC3
  @(posedge XIOR) 
  SD_REG <= 16'h0023; //from MAC1
  @(posedge XIOR) 
  SD_REG <= 16'h0024; //from MAC2
  @(posedge XIOR) 
  SD_REG <= 16'h0025; //from MAC3
  @(posedge XIOR)
  SD_REG <= 16'h0608; //ARP
  @(posedge XIOR) 
  SD_REG <= 16'h0025;
  @(posedge XIOR) 
  SD_REG <= 16'h0026;
  @(posedge XIOR) ; 
  SD_REG <= 16'h0027; 
  @(posedge XIOR) 
  SD_REG <= 16'h0028;
  @(posedge XIOR) 
  SD_REG <= 16'h0029;
  @(posedge XIOR) 
  SD_REG <= 16'h002a; 
  @(posedge XIOR) 
  SD_REG <= 16'h002b;
  @(posedge XIOR) ; 
  SD_REG <= 16'h002c;
  @(posedge XIOR) ;
  SD_REG <= 16'h002d;
  @(posedge XIOR) ;
  SD_REG <= 16'h002e; 
  @(posedge XIOR) 
  SD_REG <= 16'h002f; 
  @(posedge XIOR) 
  SD_REG <= 16'h0030; 
  @(posedge XIOR) 
  SD_REG <= 16'h0031;
  @(posedge XIOR) 
  SD_REG <= 16'h0032;
  @(posedge XIOR)  
  SD_REG <= 16'h0033;
  @(posedge XIOR)  
  SD_REG <= 16'h0034;
  @(posedge XIOR)  
  SD_REG <= 16'h0035;
  @(posedge XIOR)  
  SD_REG <= 16'h0036;
  @(posedge XIOR) 
  SD_REG <= 16'h0046;//MAX_DMA
  @(posedge XIOR) 
  SD_REG <= 16'h003d;
  @(posedge XIOR) 
  SD_REG <= 16'h003e;
  @(posedge XIOR) 
  SD_REG <= 16'h003f;
  @(posedge XIOR) 
  SD_REG <= 16'h0040;
  @(posedge XIOR) 
  SD_REG <= 16'h0041;
  @(posedge XIOR) 
  SD_REG <= 16'h0042;
  @(posedge XIOR) 
  SD_REG <= 16'h0008;//IP
  @(posedge XIOR) 
  SD_REG <= 16'h0039;
  @(posedge XIOR) 
  SD_REG <= 16'h003a; 
  @(posedge XIOR) 
  SD_REG <= 16'h003b;
  @(posedge XIOR) ; 
  SD_REG <= 16'h003c;
  @(posedge XIOR) ;
  SD_REG <= 16'h013d; // ICMP
  @(posedge XIOR) ;
  SD_REG <= 16'h003e;
  @(posedge XIOR) ;
  SD_REG <= 16'h003f;
  @(posedge XIOR) 
  SD_REG <= 16'h0040;
  @(posedge XIOR) 
  SD_REG <= 16'h0041; 
  @(posedge XIOR) 
  SD_REG <= 16'h0042; 
  @(posedge XIOR) 
  SD_REG <= 16'h0043;
  @(posedge XIOR) 
  SD_REG <= 16'h0044;
  @(posedge XIOR) 
  SD_REG <= 16'h0045;
  @(posedge XIOR) 
  SD_REG <= 16'h0046;
  @(posedge XIOR) 
  SD_REG <= 16'h0047; 
  @(posedge XIOR) 
  SD_REG <= 16'h0048;
  @(posedge XIOR) 
  SD_REG <= 16'h0049;
  @(posedge XIOR) 
  SD_REG <= 16'h004a; 
  @(posedge XIOR) 
  SD_REG <= 16'h004b;
  @(posedge XIOR) ; 
  SD_REG <= 16'h004c;
  @(posedge XIOR) ;
  SD_REG <= 16'h004d;
  @(posedge XIOR) ;
  SD_REG <= 16'h004e;
  @(posedge XIOR) ;
  SD_REG <= 16'h004e;
  @(posedge XIOR) ;
  SD_REG <= 16'h004f;
  @(posedge XIOR) ; 
  SD_REG <= 16'h0020; 
  @(posedge XIOR) 
  SD_REG <= 16'h0021; 
  @(posedge XIOR) 
  SD_REG <= 16'h0022; 
  @(posedge XIOR) 
  SD_REG <= 16'h0023;
  @(posedge XIOR) 
  SD_REG <= 16'h0024; 
  @(posedge XIOR) 
  SD_REG <= 16'h0025; 
  @(posedge XIOR) 
  SD_REG <= 16'h0026;  
  @(posedge XIOR) 
  SD_REG <= 16'h0027; 
  @(posedge XIOR)
  //     SYN ,ACK ,PSH ,FIN 
  TASK_CNT <= TASK_CNT + 8'd1;
  TCP_PK(1'b1,1'b0,1'b0,1'b0); //SYN,ACK,PSH,FIN    
  SD_REG <= 16'h0001;
  @(posedge XIOR) ;  
  TASK_CNT <= TASK_CNT + 8'd1;
  TCP_PK(1'b0,1'b1,1'b0,1'b0);
  TASK_CNT <= TASK_CNT + 8'd1;
  TCP_PK(1'b0,1'b1,1'b1,1'b0); 
  TASK_CNT <= TASK_CNT + 8'd1;
  TCP_PK(1'b0,1'b1,1'b0,1'b0); 
  TASK_CNT <= TASK_CNT + 8'd1;
  TCP_PK(1'b0,1'b1,1'b0,1'b1); 
  TASK_CNT <= TASK_CNT + 8'd1;
  TCP_PK(1'b1,1'b0,1'b0,1'b0); 
  TASK_CNT <= TASK_CNT + 8'd1;
  TCP_PK(1'b0,1'b1,1'b0,1'b0);



  end


task TCP_PK;
input SYN;
input ACK;
input PSH;
input FIN;
begin
  SD_REG <= 16'h0001; 
  @(posedge XIOR) 
  SD_REG <= 16'h002a; 
  @(posedge XIOR) 
  SD_REG <= 16'h002b;
  @(posedge XIOR)
  SD_REG <= 16'h002c;
  @(posedge XIOR) 
  SD_REG <= 16'h004e;  // MAX_DMA
  @(posedge XIOR) 
  SD_REG <= 16'h0020; //to MAC1
  @(posedge XIOR) 
  SD_REG <= 16'h0021; //to MAC2 
  @(posedge XIOR) 
  SD_REG <= 16'h0022; //to MAC3
  @(posedge XIOR) 
  SD_REG <= 16'h0023; //from MAC1
  @(posedge XIOR) 
  SD_REG <= 16'h0024; //from MAC2
  @(posedge XIOR) 
  SD_REG <= 16'h0025; //from MAC3
  @(posedge XIOR) 
  SD_REG <= 16'h0008; //TYPE IP
  @(posedge XIOR) 
  SD_REG <= 16'h0027; //Version,Header_length,TOS
  @(posedge XIOR) 
  SD_REG <= 16'h0051;//all Data length 
  //SD_REG <= 16'h0061;//all Data length
  @(posedge XIOR) 
  SD_REG <= 16'h0029; //ID
  @(posedge XIOR) 
  SD_REG <= 16'h002a; //flg,off_set
  @(posedge XIOR) 
  SD_REG <= 16'h062b; //TTL,PRT_NO(TCP)
  @(posedge XIOR) 
  SD_REG <= 16'h002c; //CHK_SUM
  @(posedge XIOR)
  SD_REG <= 16'h002d; //from IP1
  @(posedge XIOR)
  SD_REG <= 16'h002e; //from IP2
  @(posedge XIOR)
  SD_REG <= 16'h002f; //to IP1
  @(posedge XIOR) 
  SD_REG <= 16'h0020; //to IP2
  @(posedge XIOR) 
  //SD_REG <= 16'h0200; //OP1
  //@(posedge XIOR) ;
  //SD_REG <= 16'hb405; //OP2
  //@(posedge XIOR) ;    
  SD_REG <= 16'h0021; //from PORT
  @(posedge XIOR) 
  SD_REG <= 16'h5000; //to PORT
  @(posedge XIOR) 
  SD_REG <= 16'h0023; //SEQ_NO
  @(posedge XIOR)  
  SD_REG <= 16'h0023; //SEQ_NO
  @(posedge XIOR) 
  SD_REG <= 16'h0024; //ACK_NO
  @(posedge XIOR) 
  SD_REG <= 16'h0024; //ACK_NO
  @(posedge XIOR) 
  SD_REG <= {3'b000,ACK,PSH,1'b0,SYN,FIN,8'h25}; //flg
  @(posedge XIOR) 
  SD_REG <= 16'h0026; //win_size
  @(posedge XIOR) 
  SD_REG <= 16'h0027; 
  @(posedge XIOR) ; 
  SD_REG <= 16'h0028; 
  @(posedge XIOR) 
  SD_REG <= 16'h0029;
  @(posedge XIOR) 
  SD_REG <= 16'h002a;
  @(posedge XIOR) 
  SD_REG <= 16'h042b; 
  @(posedge XIOR) 
  SD_REG <= 16'h062c;
  @(posedge XIOR) ; 
  SD_REG <= 16'h002d;
  @(posedge XIOR) ;
  SD_REG <= 16'h002e;
  @(posedge XIOR) ;
  SD_REG <= 16'h002f;
  @(posedge XIOR) ;
  SD_REG <= 16'h0020;
  @(posedge XIOR) ;   
  SD_REG <= 16'h0021;
  @(posedge XIOR) ;   
  SD_REG <= 16'h0022;
  @(posedge XIOR) ;   
  SD_REG <= 16'h0023;
  @(posedge XIOR) ;   
  SD_REG <= 16'h0024;
  @(posedge XIOR) ;   
  SD_REG <= 16'h0025;
  @(posedge XIOR) ;  
  SD_REG <= 16'h0026;
  @(posedge XIOR) ;   
  SD_REG <= 16'h0027;
  @(posedge XIOR) ;   
  //SD_REG <= 16'h0001;
  //@(posedge XIOR) ;   
  //SD_REG <= 16'h0029;
  //@(posedge XIOR) ; 
  end
endtask




initial begin
    CLK <= 1'b0;
    RST <= 1'b1;
    IRQ3 <=1'b1; 
    IRQ4 <=1'b1;
    IRQ5 <=1'b1;
    IRQ7 <=1'b1;
    IRQ9 <=1'b1;
    IRQ10 <=1'b1;
    IRQ11 <=1'b1;
    IRQ12 <=1'b1;
    //DTR <= 1'b0 ;
    //TXD <= 1'b0 ;
    XIOCHDRY <= 1'b1 ;
    SEND <= 0;
    SEND_DT <=8'h00;
    #(CYCLE*10)
    //CLK <= 0 ;
    RST <= 1'b0 ;
    //DTR <= 0 ;
    //TXD <= 0 ;
    //XIOCHDRY <= 0 ;
    //SD_I <= 0 ;
    #(CYCLE*10);
    SEND_DT <= 8'h99;
    SEND <= 1'b1;
    #(CYCLE)
    SEND <= 1'b0;
    #(CYCLE*TIME_1);
    SEND_DT <= 8'h01;
    SEND <= 1'b1;
    #(CYCLE)
    SEND <= 1'b0;
    #(CYCLE*TIME_1);
    SEND_DT <= 8'h02;
    SEND <= 1'b1;
    #(CYCLE)
    SEND <= 1'b0;
    #(CYCLE*TIME_1);
    SEND_DT <= 8'h03;
    SEND <= 1'b1;
    #(CYCLE)
    SEND <= 1'b0;
    #(CYCLE*TIME_1);
    SEND_DT <= 8'h04;
    SEND <= 1'b1;
    #(CYCLE)
    SEND <= 1'b0;
    #(CYCLE*TIME_1); 
    SEND_DT <= 8'h91;
    SEND <= 1'b1;
    #(CYCLE)
    SEND <= 1'b0;
    #(CYCLE*TIME_1);
    SEND_DT <= 8'h05;
    SEND <= 1'b1;
    #(CYCLE)
    SEND <= 1'b0;
    #(CYCLE*TIME_1);
    SEND_DT <= 8'h06;
    SEND <= 1'b1;
    #(CYCLE)
    SEND <= 1'b0;
    #(CYCLE*TIME_1);
    SEND_DT <= 8'h07;
    SEND <= 1'b1;
    #(CYCLE)
    SEND <= 1'b0;
    #(CYCLE*TIME_1); 
    SEND_DT <= 8'h99;
    SEND <= 1'b1;
    #(CYCLE)
    SEND <= 1'b0;
    #(CYCLE*TIME_1);
    SEND_DT <= 8'h08;
    SEND <= 1'b1;
    #(CYCLE)
    SEND <= 1'b0;
    #(CYCLE*TIME_1);
    SEND_DT <= 8'h08;
    SEND <= 1'b1;
    #(CYCLE)
    SEND <= 1'b0;
    #(CYCLE*TIME_1);
    SEND_DT <= 8'h09;
    SEND <= 1'b1;
    #(CYCLE)
    SEND <= 1'b0;
    #(CYCLE*TIME_1);
    SEND_DT <= 8'h0a;
    SEND <= 1'b1;
    #(CYCLE)
    SEND <= 1'b0;
    #(CYCLE*TIME_1);
end


//
//wave montor for Veriwell
//  initial  $vw_dumpvars (); 
  endmodule 
