//module:REG_UNIT  
//Ver 0.50
//date 20/01/2003
//Kenji Yokomizo <kyokomi@mvi.biglobe.ne.jp>
//
module  REG_UNIT (CLK,RST,W_H,W_L,DA_I_H,DA_I_L,DA_O_H,DA_O_L);
input CLK,RST;
input W_H,W_L;
input [7:0]DA_I_H;
input [7:0]DA_I_L;
output[7:0]DA_O_H;
output[7:0]DA_O_L;

reg [7:0]DA_O_L;
reg [7:0]DA_O_H;

always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1)
    begin
      DA_O_L <= 8'h00;
      DA_O_H <= 8'h00;
    end
  else
    begin
      if (W_L==1'b1)
        DA_O_L <= DA_I_L;
      else
        DA_O_L <= DA_O_L;
      if (W_H==1'b1)
        DA_O_H <= DA_I_H;
      else
        DA_O_H <= DA_O_H;
    end
end
endmodule
