//module:ISA_SV  
//Ver 0.50
//date 20/01/2003
//Kenji Yokomizo <kyokomi@mvi.biglobe.ne.jp>

module  WEB_BLK  ( CLK,XRST
                 //,DSR,RXD,DTR,TXD 
                 ,RESET_DEV,XSMEMW,XSMEMR,XIOW,XIOR,ISA_CLK,BALE,AEN,SD,SA,XMEMR,XMEMW,XIOCHDRY
		           //,XIOCS6,IRQ3,IRQ4,IRQ5,IRQ7,IRQ9,IRQ10,IRQ11,IRQ12
                 ,LED,LED_SEL);
input   CLK; 
input   XRST; 
//output   DSR;
//output   RXD;
//input  DTR;
//input  TXD;
// ISA IF
output RESET_DEV;
output XSMEMW;
output XSMEMR;
output XIOW;
output XIOR;
output ISA_CLK;
output BALE;
input  XIOCHDRY;
output AEN;
inout  [15:0] SD;
output [19:0]SA;
//input  XIOCS6;
output XMEMR;
output XMEMW;
//
output [7:0]LED;
output[4:0] LED_SEL;

//
//input IRQ3;
//input IRQ4;
//input IRQ5;
//input IRQ7;
//input IRQ9;
//input IRQ10;
//input IRQ11;
//input IRQ12;
//
//wire SEND;
//wire [7:0] SEND_DT;
//wire RCV;
//wire [7:0] RCV_DT;
//wire S_BUSY;

wire TCP_SW;
wire [7:0]DATA_IN;

   ISA_SV ISA_SV_1(
     .CLK(CLK),
     .XRST(XRST),
    // .DTR(DTR),
    // .TXD(TXD),
     .XIOCHDRY(XIOCHDRY),
    //.DSR(DSR),
    //.RXD(RXD),
     .RESET_DEV(RESET_DEV),
     .XSMEMW(XSMEMW),
     .XSMEMR(XSMEMR),
     .XIOW(XIOW),
     .XIOR(XIOR),
     .ISA_CLK(ISA_CLK),
     .BALE(BALE),
     .AEN(AEN),
     .SD(SD),
     .SA(SA),
     .LED(LED),
     .LED_SEL(LED_SEL),
     .TCP_SW(TCP_SW),
     .DATA_IN(DATA_IN),
     .DATA_IN_EN(DATA_IN_EN),
     .DATA_OUT(DATA_OUT),
     .DATA_OUT_EN(DATA_OUT_EN)
     ); 

   USER_BLK USER_BLK_1(
     .CLK(CLK),
     .XRST(XRST),     
     .TCP_SW(TCP_SW),
     .DATA_IN(DATA_IN),
     .DATA_IN_EN(DATA_IN_EN),
     .DATA_OUT(DATA_OUT),
     .DATA_OUT_EN(DATA_OUT_EN)
     );

endmodule
